package com.ljmin.action;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Date;

import org.apache.struts2.ServletActionContext;

import com.opensymphony.xwork2.ActionSupport;

@SuppressWarnings("serial")
public class UploadAction extends ActionSupport {
	private File myFile;
	private String fileName;
	private String saveName;
	private static final int BUFFER_SIZE = 8 * 1024;

	public String input() {
		return "input";
	}

	public String upload() {
		/* 截取后缀名 */
		int pos = fileName.lastIndexOf(".");
		String str = fileName.substring(pos);
		// 时间加后缀名保存
		saveName = new Date().getTime() + str;
		// 根据服务器的文件保存地址和原文件名创建目录文件全路径
		File imageFile = new File(ServletActionContext.getServletContext()
				.getRealPath("upload")
				+ "/" + saveName);
		copy(myFile, imageFile);

		return "upload";
	}

	// 复制方法
	public static void copy(File src, File dst) {
		try {
			InputStream in = null;
			OutputStream out = null;
			try {
				in = new BufferedInputStream(new FileInputStream(src),
						BUFFER_SIZE);
				out = new BufferedOutputStream(new FileOutputStream(dst),
						BUFFER_SIZE);
				byte[] buffer = new byte[BUFFER_SIZE];
				while (in.read(buffer) > 0) {
					out.write(buffer);
				}
			} finally {
				if (null != in) {
					in.close();
				}
				if (null != out) {
					out.close();
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	//得到文件名
	public void setMyFileFileName(String fileName) {
		this.fileName = fileName;
	}

	public File getMyFile() {
		return myFile;
	}

	public void setMyFile(File myFile) {
		this.myFile = myFile;
	}

	public String getFileName() {
		return fileName;
	}

	public void setFileName(String fileName) {
		this.fileName = fileName;
	}

	public String getSaveName() {
		return saveName;
	}

	public void setSaveName(String saveName) {
		this.saveName = saveName;
	}

}
